#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# IMPORTANT:
# This script must be run with root rights.
#
# sudo -s
# python ssidcollect_linux.py
#
# by Daniel Müllner, muellner@math.stanford.edu
# Modified for Maemo 5 by Michael Robinson, dr.michael.robinson@gmail.com
#
# Copyright (c) 2011, Daniel Müllner, Michael Robinson
# Distribution of unaltered copies permitted for noncommercial use only
# All other uses require express permission of the author
# This software comes with no warrantees express or implied 

from subprocess import Popen, PIPE, STDOUT
from time import time
from re import search, finditer, MULTILINE
import sys

while True:
    process = Popen(['iwlist','scan'], stdout=PIPE, stderr=PIPE)
    stdout, stderr = process.communicate()
    timestamp = time()
    match = finditer('Address: (..:..:..:..:..:..).*\n.*\n.*\n.*\n.*\n.*Signal level:([-0-9]*) dBm.*', stdout, MULTILINE)
    for f in match:
        print '%s %s %s' % (timestamp, f.group(1), f.group(2))
    sys.stdout.flush()
